<?php
require 'start.php';
// Flat file database import script for WSN Links

/* Configure this section to your needs */

$filename = 'links.txt'; // put the name of the links database file here
$catsfilename = 'categories.txt'; // put the name of the file containing category data here

$linksep = '
'; // Please identify the unique character sequence which separates link entries in the file
$fieldsep = '|'; // Please identify the unique character sequence which separates fields in each link

/*Example:
1|The Ace Magic Club|http://members.lycos.co.uk/theaceclub/|06-Aug-2004|Arts_and_Entertainment|Magical society. History, news and events.||info@astonmagic.co.uk|0|No|No|0|0|Yes 
*/

$datenotunix = true; // if date in 08-09-04 sort of format, set as true 
$catnotid = true; // set as true if category is name rather than id

$titleloc = '1'; // The number, counding from left to right starting at ZERO of the term where the link title appears within each link line
$descriploc = ''; // # of the term where the link description appears within each link line
$votesloc = ''; // # of the term where the link's total number of votes appears within each link line
$sumofvotesloc = ''; // # of the term where the link's total number of vote values appears within each link line
$ratingloc = ''; // # of the term where the link rating appears within each link line
$urlloc = '2'; // # of the term where the link URL appears within each link line
$reciploc = ''; // # of the term where the link reciprocal URL appears within each link line
$hitsoutloc = ''; // # of the term where the link hits out appears within each link line
$hitsinloc = ''; // # of the term where the link hits in appears within each link line
$catidloc = '4'; // # of the term where the link's category id number appears within each link line
$emailloc = '';  // # of the term where the email address of the link submitter appears within each link line
$typeloc = '';  // # of the term where the link type of this link appears within each link line
$dateloc = '3';

$catsep = '
'; // Please identify the unique character sequence which separates category entries in the file
$catfieldsep = '|'; // Please identify the unique character sequence which separates fields in each cat
$catnameispath = true; // true if it uses a path instead of a plain category name
$catremoveunderscores = true; // true if name has underscores needing to be changed to spaces
$cattheidloc = '0';
$catnameloc = '1';
$catparentloc = '';
/* End configuration section */

$thefile = trim(fileread($catsfilename));
$catdata = explode($catsep, $thefile);
$num = sizeof($catdata);
for ($x=0; $x<$num; $x++)
{
 $catline = explode($catfieldsep, $catdata[$x]);
 $thiscat = new onelink('blank', 'blank');
 $thiscat->validated = 1; 
 $thiscat->hide = 0;
 $thiscat->id = $catline[$cattheidloc]; 
 if ($dateloc)
 {
  if ($datenotunix) $thiscat->time = strtotime($catline[$dateloc]);
  else $thiscat->time = $catline[$dateloc];  
 }
 else $thiscat->time = time();
 $thiscat->name = $catline[$catnameloc];
 $thiscat->parentids = $thiscat->name; 
 if ($catremoveunderscores) $thiscat->name = str_replace('_', ' ', $thiscat->name);
 if ($catnameispath && strstr($thiscat->name, '/'))
 {
   $parts = explode('/', $thiscat->name);
   $qn = sizeof($parts);   
   $thiscat->name = end($parts);
   $parentpath = ''; $parpar = '';   
   for ($q=0; $q<($qn - 1); $q++)
   {
	 if ($q < ($qn - 2)) $parpar .= $parts[$q] .'/'; 
	 $parentpath .= $parts[$q] .'/';   
	}   
	$par = $parts[$qn-2];
   $thiscat->parentnames = $parentpath;
   // calculate parent id
   $gp = $db->select('id', 'categoriestable', "name='$par' and parentnames='$parpar'", '', '');
   $thiscat->parent = $db->rowitem($gp);
 }
 else { $thiscat->parent = 0; } 
 $thiscat->type = 'regular';
 $id = $thiscat->id; $name = $thiscat->name; $parentids = $thiscat->parentids; $parentnames = $thiscat->parentnames; $parent = $thiscat->parent; $type = $thiscat->type;
 if ($name != '')
 {
  echo "Adding category ". $thiscat->name ."... ";	 
  $db->insert('categoriestable', 'id,name,parentids,parentnames,parent,type,validated,hide', "'$id','$name','$parentids','$parentnames','$parent','$type','1','0'");
  }  
}
echo "<p>Done importing categories.</p>";


$thefile = trim(fileread($filename));
$linkdata = explode($linksep, $thefile);
$num = sizeof($linkdata);
for ($x=0; $x<$num; $x++)
{
 $linkline = explode($fieldsep, $linkdata[$x]);
 $thislink = new onelink('blank', 'blank');
 $thislink->validated = 1;
 $thislink->hide = 0;
 if ($dateloc)
 {
  if ($datenotunix) $thislink->time = strtotime($linkline[$dateloc]);
  else $thislink->time = $linkline[$dateloc];  
 }
 else $thislink->time = time();
 $thislink->type = 'regular';
 $thislink->email = $linkline[$emailloc];
 $thislink->title = $linkline[$titleloc];
 $thislink->url = $linkline[$urlloc];
 $thislink->hits = $linkline[$hitsoutloc];
 $thislink->hitsin = $linkline[$hitsinloc];
 $thislink->rating = $linkline[$ratingloc];
 $thislink->votes = $linkline[$votesloc];
 $thislink->sumofvotes = $linkline[$sumofvotesloc];
 $thislink->recipurl = $linkline[$reciploc];
 $thislink->description = $linkline[$descriploc];
 $thislink->catid = $linkline[$catidloc];
 if ($catnotid) $thislink->catid = $db->rowitem($db->select('id', 'categoriestable', "parentids='". $linkline[$catidloc] ."'", '', ''));
 if ($thislink->catid < 1) die ("category not found");

 echo "Adding link <a href=". $thislink->url .">". $thislink->title ."</a> to category #". $thislink->catid ."... ";
 $thislink->add();
}
echo "<p>Done importing links. You now need to regenerate counters, and the import will be complete. <a href=admin/updatecounters.php?action=deleteorphans&regenall=1>Click here</a> to do so.</p>";
?>